<?php

/**
 * Test: NFileResponse and range.
 *
 * @author     David Grudl
 * @package    Nette\Config
 */



require dirname(__FILE__) . '/../bootstrap.php';



$file = __FILE__;
$fileResponse = new NFileResponse($file);
$origData = file_get_contents($file);

ob_start();
$fileResponse->send(
	new NHttpRequest(new NUrlScript, NULL, NULL, NULL, NULL, array('range' => 'bytes=10-20')),
	$response = new NHttpResponse
);
Assert::same( substr($origData, 10, 11), ob_get_clean() );
Assert::same( 206, $response->getCode() );


ob_start();
$fileResponse->send(
	new NHttpRequest(new NUrlScript, NULL, NULL, NULL, NULL, array('range' => 'bytes=10-10')),
	new NHttpResponse
);
Assert::same( substr($origData, 10, 1), ob_get_clean() );


ob_start();
$fileResponse->send(
	new NHttpRequest(new NUrlScript, NULL, NULL, NULL, NULL, array('range' => 'bytes=10-' . filesize($file))),
	new NHttpResponse
);
Assert::same( substr($origData, 10), ob_get_clean() );


// prefix
ob_start();
$fileResponse->send(
	new NHttpRequest(new NUrlScript, NULL, NULL, NULL, NULL, array('range' => 'bytes=20-')),
	new NHttpResponse
);
Assert::same( substr($origData, 20), ob_get_clean() );


ob_start();
$fileResponse->send(
	new NHttpRequest(new NUrlScript, NULL, NULL, NULL, NULL, array('range' => 'bytes=' . (filesize($file) - 1) . '-')),
	new NHttpResponse
);
Assert::same( substr($origData, -1), ob_get_clean() );


ob_start();
$fileResponse->send(
	new NHttpRequest(new NUrlScript, NULL, NULL, NULL, NULL, array('range' => 'bytes=' . filesize($file) . '-')),
	$response = new NHttpResponse
);
Assert::same( '', ob_get_clean() );
Assert::same( 416, $response->getCode() );


// suffix
ob_start();
$fileResponse->send(
	new NHttpRequest(new NUrlScript, NULL, NULL, NULL, NULL, array('range' => 'bytes=-20')),
	new NHttpResponse
);
Assert::same( substr($origData, -20), ob_get_clean() );


ob_start();
$fileResponse->send(
	new NHttpRequest(new NUrlScript, NULL, NULL, NULL, NULL, array('range' => 'bytes=-' . filesize($file))),
	new NHttpResponse
);
Assert::same( $origData, ob_get_clean() );
